AppTitle "Space RPG"

Print "Vollbild? [y/n]"
code=WaitKey()
If code=121 Then mode=1
If code=110 Then mode=2

Graphics3D 640,480,32,mode
SetBuffer BackBuffer()
Global camera=CreateCamera()
CameraRange camera,.1,100000
EntityType camera,1
EntityRadius camera,2
Global light=CreateLight(3)
PositionEntity light,2000,500,-2000
LightRange light,8000

Global ms=MilliSecs()
Global enemyms=MilliSecs()
Global mx#=0
Global my#=0
Global laser
Global engine
Global erz
Global sprung
Global mox,moy,mob,mob2
Global maxspeed#,maxshield
Global shield#
Global money
Global px#,py#,pz#
Global level,ep
Global save=ReadFile("save.txt")
Global sector$="Alpha Centauri"
Global msg$
Global ms2=MilliSecs()
Global ms4=MilliSecs()
Global levelep
money=ReadLine(save)
laser=ReadLine(save)
engine=ReadLine(save)
shield=ReadLine(save)
px=ReadLine(save)
py=ReadLine(save)
pz=ReadLine(save)
level=ReadLine(save)
ep=ReadLine(save)
erz=ReadLine(save)
sector=ReadLine(save)
CloseFile save
PositionEntity camera,px,py,pz
If engine=1 Then maxspeed#=40
If engine=2 Then maxspeed#=60
If engine=3 Then maxspeed#=80

Global asttex=LoadTexture("gfx/tex3.png")
ScaleTexture asttex,0.5,0.5
Global asteroid=CreateSphere()
EntityTexture asteroid,asttex
PositionEntity asteroid,-20,0,0

Global planettex2=LoadTexture("gfx/tex4.png")
ScaleTexture planettex2,0.2,0.2

Global ship=LoadMesh("gfx/spaceship.3ds")
ScaleEntity ship,0.5,0.5,0.5
Global metaltex=LoadTexture("gfx/tex2.png")
ScaleTexture metaltex,0.5,0.5
EntityTexture ship,metaltex
PositionEntity ship,99999999999999999999,0,0

Dim asteroids(50),ax(50),ay(50),az(50),aerz(50),be(50)
For i=1 To 50
	ax(i)=Rnd(-50,50)*2
	ay(i)=Rnd(-50,50)*2
	az(i)=Rnd(-50,50)*2
	aerz(i)=Rnd(1,5)
	be(i)=1
	asteroids(i)=CreateSphere()
	EntityTexture asteroids(i),asttex
	PositionEntity asteroids(i),ax(i),ay(i),az(i)
	EntityType asteroids(i),2
Next

Dim enemy(20),enx(50),eny(50),enz(50),enmoney(50),enlife(50),ebe(50),enep(20)
For i=1 To 20
	enx(i)=Rnd(-100,100)*2
	eny(i)=Rnd(-100,100)*2
	enz(i)=Rnd(-100,100)*2
	enmoney(i)=Rnd(8,12)
	If sector="Alpha Centauri" Then enlife(i)=20
	If sector="Beta Centauri" Then enlife(i)=40
	If sector="Gamma Centauri" Then enlife(i)=50
	enemy(i)=CopyMesh(ship)
	EntityTexture enemy(i),metaltex
	ScaleEntity enemy(i),0.2,0.2,0.2
	PositionEntity enemy(i),enx(i),eny(i),enz(i)
	EntityType enemy(i),2
	ebe(i)=1
	If sector="Alpha Centauri" Then enep(i)=7
	If sector="Beta Centauri" Then enep(i)=14
	If sector="Gamma Centauri" Then enep(i)=20
Next

Dim stars(100),starx(100),stary(100),starz(100)
Global star=CreateTexture(50,50)
SetBuffer TextureBuffer(star)
Color 255,255,255
Rect 0,0,50,50
For i=1 To 100
	stars(i)=CreateSprite()
	ScaleSprite stars(i),1.5,1.5
	EntityTexture stars(i),star
	starx(i)=Rnd(-100,100)*8
	stary(i)=Rnd(-100,100)*8
	starz(i)=Rnd(-100,100)*8
Next

SetBuffer BackBuffer()

Global starsphere=CreateSphere()
ScaleEntity starsphere,20000,20000,20000
FlipMesh starsphere
EntityFX starsphere,1
EntityColor starsphere,0,0,0

Global planet=CreateSphere(100)
ScaleEntity planet,200,200,200
PositionEntity planet,400,-100,200
Global planettex=LoadTexture("gfx/tex1.png")
ScaleTexture planettex,0.2,0.2
EntityTexture planet,planettex
EntityType planet,2

Global cursor=LoadImage("gfx/cursor.png")
MaskImage cursor,255,0,255

Global lasersfx=LoadSound("sfx/laser.wav")
Global explsfx=LoadSound("sfx/explosion.wav")

PointEntity light,planet

Global speed#=0

HidePointer

Global stat1.Station=New Station
stat1\mesh=CreateCube()
EntityType stat1\mesh,2
ScaleEntity stat1\mesh,3,3,3
EntityTexture stat1\mesh,metaltex

Collisions 1,2,2,2

Repeat
	If stat1\docked=0 And sprung=0 Then
		mx=mx-MouseXSpeed()/500.0
		my=my+MouseYSpeed()/500.0
		MoveMouse 640/2,480/2
		TurnEntity camera,my,mx,0 
		MoveEntity camera,0,0,speed
		mx=mx*.99
		my=my*.99 
		If KeyDown(17) And speed<maxspeed/200 Then speed=speed+0.002
		If KeyDown(31) And speed>0 Then speed=speed-0.002
	EndIf
	mox=MouseX()
	moy=MouseY()
	mob=MouseHit(1)
	mob2=MouseDown(2)
	PositionEntity starsphere,EntityX(camera),EntityY(camera),EntityZ(camera)
	For i=1 To 100
		PositionEntity stars(i),starx(i)+EntityX(camera),stary(i)+EntityY(camera),starz(i)+EntityZ(camera)
	Next
	TurnEntity planet,0,0.07,0
	If MilliSecs()>enemyms+100000 Then
		For i=1 To 20
			If ebe(i)=0 Then ShowEntity enemy(i)
			If ebe(i)=0 Then ebe(i)=1
			If sector="Alpha Centauri" Then enlife(i)=20
			If sector="Beta Centauri" Then enlife(i)=40
			If sector="Gamma Centauri" Then enlife(i)=50
			CameraProject camera,EntityX(enemy(i)),EntityY(enemy(i)),EntityZ(enemy(i))			
		Next
		enemyms=MilliSecs()
	EndIf
	UpdateLasers()
	UpdateStations()
	UpdateExplosions()
	UpdateWorld
	RenderWorld
	If MouseDown(1) And MilliSecs()>ms+300 And stat1\docked=0 And sprung=0 Then
		PlaySound(lasersfx)
		NewLaser(camera,laser,-1)
		ms=MilliSecs()
	EndIf
	Color (255,255,255)
	If EntityInView(stat1\mesh,camera) Then
		Color 86,188,86
		Rect ProjectedX()-15,ProjectedY()-15,30,30,0
		Color 0,0,0
		Rect ProjectedX()-14,ProjectedY()-14,28,28,0
		Color (255,255,255)
		Text ProjectedX()+16,ProjectedY()-5,stat1\name
	EndIf
	For i=1 To 50
		If EntityDistance(camera,asteroids(i))<5 And be(i)=1 Then
			Text 320,360,"Zum Abbauen Leertaste drcken",1
			If KeyHit(57) Then
				be(i)=0
				Message("EP +2, Erz +"+aerz(i))
				HideEntity asteroids(i)
				erz=erz+aerz(i)
				ep=ep+2
			EndIf
		EndIf
	Next
	If EntityDistance(camera,stat1\mesh)<15 Then
		Color (255,255,255)
		If stat1\docked=0 And sprung=0 Then Text 320,460,"Zum Andocken Leertaste drcken",1
		If stat1\docked=1 Then Text 320,460,"Zum Abdocken Enter drcken",1
		If KeyHit(57) And stat1\docked=0 And sprung=0 Then
			stat1\docked=1
		Else If KeyHit(28) And stat1\docked=1 Then
			stat1\docked=0
		End If
	EndIf
	maxshield=90+level*10
	For schuss.laser = Each Laser	
		For a=1 To 20
			If EntityCollided(schuss\mesh,2)=enemy(a) Then
				If laser=1 Then enlife(a)=enlife(a)-10
				If laser=2 Then enlife(a)=enlife(a)-15
				If laser=3 Then enlife(a)=enlife(a)-20
				If enlife(a)<=0 And ebe(a)=1 Then 
					;EmitSound(explsfx,enemy(a))
					PlaySound explsfx
					Message("EP +"+enep(a)+", Money +"+enmoney(a)+" $")
					ep=ep+enep(a)
					money=money+enmoney(a)
					ebe(a)=0
				EndIf
			ElseIf EntityDistance(schuss\mesh,camera)<1 Then
				shield=shield-0.1
			End If
		Next
	Next
	UpdateEnemies(1)
	UpdateMessages(1)
	If stat1\docked=0 And sprung=0 Then
		Text 10,10,"Speed: "+Int(speed*200)+" m/s"
		Text 540,10,"Hlle: "+Int(shield)
		Line 320-16,240,320+16,240
		Line 320,240-16,320,240+16
	EndIf
	If stat1\docked=1 Then
		Color 64,64,64
		Rect 50,50,540,380,1
		Color 0,0,0
		Rect 50,50,540,380,0
		Color 0,0,0
		Text 320,55,stat1\name,1
		Text 320,70,stat1\info,1
		Text 55,415,"Geld: "+money+" $"
		If sector="Alpha Centauri" Then 
			Button("Ionenkanone kaufen",210,100)
			Color (0,0,0)
			Text 55,120,"Kosten: 200$"
			Text 55,140,"Neue leistungsstarke Waffe"
			If laser=2 Then
				Color 254,0,0
				Text 300,130,"Du hast diese Waffe bereits!"
			EndIf
			If Buttonpressed(210,100)=1 And laser=1 And money>=200 Then
				laser=2
				money=money-200
			EndIf
			Button("Ionentriebwerk kaufen",210,160)
			Color (0,0,0)
			Text 55,180,"Kosten: 250 $"
			Text 55,200,"Leistungsstarkes Triebwerk(60 m/s)"
			If engine=2 Then
				Color (255,0,0)
				Text 300,190,"Du hast dieses Triebwerk bereits!"
			EndIf
			If Buttonpressed(210,160) And engine=1 And money>=250 Then
				engine=2
				maxspeed=60
				money=money-250
			EndIf
		ElseIf sector="Beta Centauri" Then 
			Button("Plasmakanone kaufen",210,100)
			Color (0,0,0)
			Text 55,120,"Kosten: 400$"
			Text 55,140,"Strker als die Ionenkanone"
			If laser=3 Then
				Color 254,0,0
				Text 300,130,"Du hast diese Waffe bereits!"
			EndIf
			If Buttonpressed(210,100)=1 And laser<>3 And money>=400 Then
				laser=3
				money=money-400
			EndIf
			Button("Plasmatriebwerk kaufen",210,160)
			Color (0,0,0)
			Text 55,180,"Kosten: 450 $"
			Text 55,200,"Schneller, strker, besser(80 m/s)"
			If engine=3 Then
				Color (255,0,0)
				Text 300,190,"Du hast dieses Triebwerk bereits!"
			EndIf
			If Buttonpressed(210,160) And engine<>3 And money>=450 Then
				engine=3
				maxspeed=80
				money=money-450
			EndIf
		EndIf
		Button("Eisenerz verkaufen",210,220)
		Color (0,0,0)
		Text 55,240,"Du hast "+erz+" Erz im Laderaum"
		Text 55,260,"Dafr bekommst du "+erz*2+" $"
		If Buttonpressed(210,220)=1 Then
			money=money+erz*2
			erz=0
		EndIf
		Button("Schiff reparieren",210,280)
		Color (0,0,0)
		Text 55,300,"Kosten: "+Int((maxshield-shield)/2)+" $"
		If Buttonpressed(210,280)=1 And money>=Int((maxshield-shield)/2) Then
			money=money-Int((maxshield-shield)/2)
			shield=maxshield
		EndIf
		Button("Spiel speichern",210,320)
		Color (0,0,0)
		Text 55,340,"Kosten: 10 $"
		If Buttonpressed(210,320)=1 And money>=10 Then
			money=money-10
			save2=OpenFile("save.txt")
			WriteLine(save2,money)
			WriteLine(save2,laser)
			WriteLine(save2,engine)
			WriteLine(save2,shield)
			WriteLine(save2,EntityX(camera))
			WriteLine(save2,EntityY(camera))
			WriteLine(save2,EntityZ(camera))
			WriteLine(save2,level)
			WriteLine(save2,ep)
			WriteLine(save2,erz)
			WriteLine(save2,sector)
			CloseFile(save2)
		EndIf
		DrawImage cursor,mox,moy
	EndIf
	If mob2=1 Then
		Color 64,64,64
		Rect 50,50,540,380,1
		Color 0,0,0
		Rect 50,50,540,380,0
		Color 0,0,0
		Text 55,55,"Level: "+level+"("+ep+"/"+levelep+")"
		Text 55,75,"Geld:  "+money+" $"
		Text 55,95,"Erz:   "+erz
		If laser=1 Then Text 55,115,"Waffe: Laserkanone"
		If laser=2 Then Text 55,115,"Waffe: Ionenkanone"
		If laser=3 Then Text 55,115,"Waffe: Plasmakanone"
		If engine=1 Then Text 55,135,"Antrieb: Verbrennungstriebwerk"
		If engine=2 Then Text 55,135,"Antrieb: Ionentriebwerk"
		If engine=3 Then Text 55,135,"Antrieb: Plasmatriebwerk"
		Text 55,175,"Sektor: "+sector
	EndIf
	levelep=100+level*10
	maxshield=100+level*10
	If ep>=levelep Then
		level=level+1
		Message("Levelup auf Stufe "+level)
		ep=0
	EndIf
	If Int(shield)<=0 Then
		Color 64,64,64
		Rect 0,0,640,480,1
		Color 0,0,0
		Text 320,230,"Du wurdest abgeschossen",1
		Text 320,250,"Starte das Spiel neu um den letzten Spielstand zu laden",1
		Delay 20000000000000000
	EndIf
	If KeyHit(15) And sprung=0 Then
		sprung=1
	EndIf
	If sprung=1 Then
		Color 64,64,64
		Rect 50,50,540,380,1
		Color 0,0,0
		Rect 50,50,540,380,0
		Text 320,55,"Sprungantrieb",1
		Button("Alpha Centauri",170,80)
		Button("Beta Centauri",170,105)
		Button("Gamma Centauri",170,130)
		Color 0,0,0
		If level<5 Then Text 300,105,"Erst ab Level 5 mglich"
		If level<10 Then Text 300,130,"Erst ab Level 10 mglich"
		If Buttonpressed(170,80) Then 
			sector="Alpha Centauri"
			For i=1 To 20
				enlife(i)=20
				enep(i)=7
				enmoney(i)=Rnd(8,12)
			Next
		EndIf
		If Buttonpressed(170,105) And level>=5 Then 
			sector="Beta Centauri"
			For i=1 To 20
				enlife(i)=40
				enep(i)=14
				enmoney(i)=Rnd(10,20)
			Next
		EndIf
		If Buttonpressed(170,130) And level>=10 Then 
			sector="Gamma Centauri"
			For i=1 To 20
				enlife(i)=50
				enep(i)=20
				enmoney(i)=Rnd(15,25)
			Next
		EndIf
		DrawImage cursor,mox,moy
		Button("Schlieen",320,400)
		If Buttonpressed(320,400) Then sprung=0
	End If
	Flip 1
	Delay 1
Until KeyHit(1)
FreeSound lasersfx
FreeSound explsfx
ClearWorld()
End

Type Laser
	Field x,y,z
	Field mesh
End Type

Function UpdateLasers()
	Local a
	For schuss.Laser = Each Laser
		MoveEntity schuss\mesh,0,0,1
		If EntityCollided(schuss\mesh,2)>0 Then
			Explosion(EntityX(schuss\mesh),EntityY(schuss\mesh),EntityZ(schuss\mesh))
			HideEntity schuss\mesh
			Delete schuss
		EndIf
	Next
End Function

Function NewLaser(parent,las,y)
	schuss.Laser=New Laser
	schuss\mesh=CreateCube(parent)
	EntityParent schuss\mesh,0
	MoveEntity schuss\mesh,0,y,1
	If las=1 Then EntityColor schuss\mesh,255,0,0
	If las=2 Then EntityColor schuss\mesh,0,0,255
	If las=3 Then EntityColor schuss\mesh,0,255,0
	ScaleEntity schuss\mesh,0.05,0.05,0.2
	EntityType schuss\mesh,1
End Function

Type Station
	Field x,y,z,docked
	Field mesh
	Field name$,info$
End Type

Function UpdateStations()
	If sector<>"Gamma Centauri" Then CameraProject camera,EntityX(stat1\mesh),EntityY(stat1\mesh),EntityZ(stat1\mesh)
	If sector="Alpha Centauri" Then
		stat1\name="Berbaubasis"
		stat1\info="Dient als Basis fr die Bergbauttigkeiten auf den Meteroiten."
		stat1\x=50
		stat1\y=20
		stat1\z=100
		EntityTexture planet,planettex
	ElseIf sector="Beta Centauri" Then
		stat1\name="Leuchtturm"
		stat1\info="Die letzte Station vor dem Ende des bekannten Universums."
		stat1\x=30
		stat1\y=-80
		stat1\z=10
		EntityTexture planet,metaltex
	ElseIf sector="Gamma Centauri" Then
		stat1\y=99999999999999
		EntityTexture planet,planettex2
	EndIf
	PositionEntity stat1\mesh,stat1\x,stat1\y,stat1\z
End Function

Function Button(title$,x,y)
	Color (32,32,32)
	Rect x-100,y-2,200,20,1
	Color (0,0,0)
	Rect x-100,y-2,200,20,0
	Color (128,128,128)
	Text x,y,title,1
	If mox>x-100 And mox<x+100 And moy>y-2 And moy<y+22 Then
		Color (255,255,255)
		Text x,y,title,1
	EndIf
End Function

Function Buttonpressed(x,y)
	If mox>x-100 And mox<x+100 And moy>y-2 And moy<y+22 And mob Then
		Return 1
	Else
		Return 0
	End If
End Function

Function Explosion(x,y,z)
	expl.Explosion=New Explosion
	expl\mesh=CreateSphere()
	EntityColor expl\mesh,255,215,0
	EntityAlpha expl\mesh,0.5
	EntityFX expl\mesh,1
	PositionEntity expl\mesh,x,y,z
End Function

Function UpdateExplosions()
	For expl.Explosion=Each Explosion
		ScaleEntity expl\mesh,expl\scale,expl\scale,expl\scale
		If MilliSecs()>ms3+10 And expl\scale<1 Then
			expl\scale=expl\scale+0.1
			ms3=MilliSecs()
		EndIf 
		If expl\scale>=1 Then HideEntity expl\mesh
	Next
End Function

Type Explosion
	Field x,y,z,scale#
	Field mesh
End Type

Function UpdateEnemies(x)
	For i=1 To 20
		If ebe(i)=0 Then
			HideEntity enemy(i)
		End If
		If EntityDistance(camera,enemy(i))<120 And EntityInView(enemy(i),camera) And enlife(i)>0 Then
			If ebe(i)=1 CameraProject camera,EntityX(enemy(i)),EntityY(enemy(i)),EntityZ(enemy(i))
			Color 188,86,86
			Rect ProjectedX()-15,ProjectedY()-15,30,30,0
			Color 0,0,0
			Rect ProjectedX()-14,ProjectedY()-14,28,28,0
			Color (255,255,255)
			If sector="Alpha Centauri" And ebe(i)=1 Then 
				Text ProjectedX()+16,ProjectedY()-15,"Tee-Fighter"
				Text ProjectedX()+16,ProjectedY(),enlife(i)+"/20"
			ElseIf sector="Beta Centauri" And ebe(i)=1 Then 
				Text ProjectedX()+16,ProjectedY()-15,"Mark I"
				Text ProjectedX()+16,ProjectedY(),enlife(i)+"/40"	
			ElseIf sector="Gamma Centauri" And ebe(i)=1 Then 
				Text ProjectedX()+16,ProjectedY()-15,"Mark II"
				Text ProjectedX()+16,ProjectedY(),enlife(i)+"/50"
			EndIf
		EndIf
		If EntityDistance(camera,enemy(i))<80 And MilliSecs()>ms4+500 And stat1\docked=0 And sprung=0 And ebe(i)=1 Then
			PointEntity (enemy(i),camera)
			MoveEntity enemy(i),0,0,0.05
			If sector="Alpha Centauri" Then elas=1
			If sector="Beta Centauri" Then elas=2
			If sector="Gamma Centauri" Then elas=3
			NewLaser(enemy(i),elas,Rnd(-0.5,0.5))
			ms4=MilliSecs()
		Else
			MoveEntity enemy(i),0,0,0.1
			TurnEntity enemy(i),0,0.2,0
		End If
	Next
End Function

Function Message(title$)
	msg=title
	ms2=MilliSecs()
End Function

Function UpdateMessages(x)
	If MilliSecs()>ms2 And MilliSecs()<ms2+1000
		Color (255,255,255)
		Text 320,280,msg,1
	End If
End Function


;~IDEal Editor Parameters:
;~F#1B3#1B8#1C4#1D0#1ED#1FA#202#20B#216#241#246
;~C#Blitz3D